//+------------------------------------------------------------------+
//|                                                   ADXcrosses.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, klot"
#property link      "klot@mail.ru"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red

extern int       barn=1300;
extern int       Length=4;
extern int CandleTF = 240;
extern bool AlertOn = false;
extern bool EmailOn = false;
double g_ibuf_92[];
double g_ibuf_96[];
int gia_100[];
int gi_104 = 0;

int init() {
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0, 159);
   SetIndexBuffer(0, g_ibuf_92);
   SetIndexEmptyValue(0, 0.0);
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexArrow(1, 159);
   SetIndexBuffer(1, g_ibuf_96);
   SetIndexEmptyValue(1, 0.0);
   if (Period() > CandleTF) {
      Alert("DT-ZigZag: Please set to a higher TF ", CandleTF);
      return (0);
   }
   ArrayCopySeries(gia_100, 5, Symbol(), CandleTF);
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   int l_count_0;
   double l_icustom_4;
   int li_12 = IndicatorCounted();
   int li_16 = 300;
   if (li_12 < 0) return (-1);
   if (li_12 > 0) li_12--;
   li_16 = Bars - li_12;
   for (int l_index_20 = 0; l_index_20 < li_16; l_index_20++) {
      if (Time[l_index_20] >= gia_100[0]) l_count_0 = 0;
      else {
         l_count_0 = ArrayBsearch(gia_100, Time[l_index_20 - 1], WHOLE_ARRAY, 0, MODE_DESCEND);
         if (Period() <= CandleTF) l_count_0++;
      }
      for (int li_24 = l_count_0; li_24 < l_count_0 + 100; li_24++) {
         l_icustom_4 = iCustom(NULL, CandleTF, "myZZ", barn, Length, 0, li_24 + 1);
         if (l_icustom_4 != 0.0) break;
      }
      if (iClose(NULL, 0, l_index_20 + 1) <= l_icustom_4) g_ibuf_96[l_index_20] = l_icustom_4;
      else g_ibuf_96[l_index_20] = 0.0;
      if (iClose(NULL, 0, l_index_20 + 1) >= l_icustom_4) g_ibuf_92[l_index_20] = l_icustom_4;
      else g_ibuf_92[l_index_20] = 0.0;
      WindowRedraw();
   }
   if (g_ibuf_92[1] > 0.0 && gi_104 < 1) {
      if (AlertOn) Alert("Buy Alert on " + Symbol() + "[" + Period() + "m]");
      if (EmailOn) SendMail("Buy Alert!", "Buy alert on " + Symbol() + "[" + Period() + "m]");
      gi_104 = 1;
   } else {
      if (g_ibuf_96[1] > 0.0 && gi_104 > -1) {
         if (AlertOn) Alert("Sell Alert on " + Symbol() + "[" + Period() + "m]");
         if (EmailOn) SendMail("Sell Alert!", "Sell alert on " + Symbol() + "[" + Period() + "m]");
         gi_104 = -1;
      }
   }
   return (0);
}